<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Teknisa\MAN\Services\ExportConfigSobProdERec as ExportService;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;

class ExportConfigSobProdERec extends CrudWithParameterBag {
    
    const DATASOURCE_INSERT = 'export';
    protected $dataSourceName = 'exportConfigSobProdERec';
    private $utilService;
    private $exportService;
    protected $parameterBagColumns = array("NRORG","CDFILIAL","NRCONFTELA");
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Utilities\Util $utilService, ExportService $exportService){
        $this->utilService = $utilService;
        $this->exportService = $exportService;
        parent::__construct($dataSourceManager, $parameterBag);
    }
   
    public function exportProdutosRecebimentos(DTO\Request\Row $request, DTO\Response $response){ 
        $row = $request->getRow(); 
        $CDFILIAL = $row['CDFILIAL']; 
        $NRCONFTELA = $row['NRCONFTELA']; 
        $DTINIVIGENCIAORIG = $row['DTINIVIGENCIAORIG']; 
        $rows = $row['ROWS']; 
        if($this->exportService->exportProduto($CDFILIAL, $NRCONFTELA, $rows, $DTINIVIGENCIAORIG) && $this->exportService->exportRecebimento($CDFILIAL, $NRCONFTELA, $rows, $DTINIVIGENCIAORIG)){ 
            $sucess = true; 
        }else{ 
            $sucess = false; 
        } 
        $response->addDataSet(new DataSet(self::DATASOURCE_INSERT, array("sucess"=>$sucess))); 
    } 
    
    public function exportProduto(DTO\Request\Row $request, DTO\Response $response){ 
        $row = $request->getRow(); 
        $CDFILIAL = $row['CDFILIAL']; 
        $NRCONFTELA = $row['NRCONFTELA']; 
        $DTINIVIGENCIAORIG = $row['DTINIVIGENCIAORIG']; 
        $rows = $row['ROWS']; 
        if($this->exportService->exportProduto($CDFILIAL, $NRCONFTELA, $rows, $DTINIVIGENCIAORIG)){ 
            $sucess = true; 
        }else{ 
            $sucess = false; 
        } 
        $response->addDataSet(new DataSet(self::DATASOURCE_INSERT, array("sucess"=>$sucess))); 
    } 
    
    public function exportRecebimento(DTO\Request\Row $request, DTO\Response $response){ 
        $row = $request->getRow(); 
        $CDFILIAL = $row['CDFILIAL']; 
        $NRCONFTELA = $row['NRCONFTELA']; 
        $DTINIVIGENCIAORIG = $row['DTINIVIGENCIAORIG']; 
        $rows = $row['ROWS']; 
        if($this->exportService->exportRecebimento($CDFILIAL, $NRCONFTELA, $rows, $DTINIVIGENCIAORIG)){ 
            $sucess = true; 
        }else{ 
            $sucess = false; 
        } 
        $response->addDataSet(new DataSet(self::DATASOURCE_INSERT, array("sucess"=>$sucess))); 
    } 

}