<?php 

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class SelectCliente extends CrudWithParameterBag {
    
    protected $dataSourceName = 'select_cliente'; 
    protected $util;
    protected $dataSourceClienteMult = 'select_cliente_filialMultiplo';
    protected $dataSourceConsMult = 'consumidorClienteMult';
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag,  $util) {
        parent::__construct($dataSourceManager, $parameterBag);
        $this -> util = $util;
        
    }
    
    public function find(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'select_cliente';
        $this->parameterBagColumns = array('NRORG');
    	parent::find($request, $response);
    }
    
     public function findConsumidor(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'consumidorClienteMult';
        $this->parameterBagColumns = array('NRORG', 'CDCLIENTE', 'TCDCLIENTE'); 
        $conditions = $this->util->getParamsAsArray($request);
        $dataSourceFilter = array();
        $likeableConditions = $this->util->getLikeConditions($request);
        foreach ($likeableConditions as $condition) {
			if(array_key_exists($condition['columnName'], $conditions)) {
				 unset($conditions[$condition['columnName']]);
			}
		}
		unset($conditions['CDCONSUMIDOR']);
        $conditions = $this->util->buildParams('CDCLIENTE',$conditions);
        $newRequest = $this->util->createNewZeedhiFilterRequestObject($request, $this->dataSourceName, $conditions);
        foreach ($likeableConditions as $condition) {
			$newRequest->getFilterCriteria()->addCondition($condition['columnName'], $condition['operator'], $condition['value']);
		}
        parent::find($newRequest, $response);
    }
   

       public function findClienteMult(DTO\Request\Filter $request, DTO\Response $response){
        $this->dataSourceName = 'select_cliente_filialMultiplo';
        $this->parameterBagColumns = array('NRORG', 'CDFILIAL', 'TCDFILIAL');
        $conditions = $this->util->getParamsAsArray($request);
        
        $dataSourceFilter = array();
        $likeableConditions = $this->util->getLikeConditions($request);
        foreach ($likeableConditions as $condition) {
			if(array_key_exists($condition['columnName'], $conditions)) {
				 unset($conditions[$condition['columnName']]);
			}
		}
        $conditions = $this->util->buildParams('CDFILIAL',$conditions);
        $newRequest = $this->util->createNewZeedhiFilterRequestObject($request, $this->dataSourceName, $conditions);
        foreach ($likeableConditions as $condition) {
			$newRequest->getFilterCriteria()->addCondition($condition['columnName'], $condition['operator'], $condition['value']);
		}
        parent::find($newRequest, $response);
    }
   
}