<?php
namespace Teknisa\MAN\Factories;

use Doctrine\ORM\EntityManager;

class CadConsumidorDadosFactory {

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    public function findConsResp($row){
        $sql = "SELECT
                   CDCLIENTE, CDCONSUMIDOR, NMCONSUMIDOR, NRRGCONSUMID, 
                   CDSENHASITE, NRCPFRESPCON, NMRESPCONS, NMLOGINCONS
                FROM
                   CONSUMIDOR
                 WHERE
                   (CDCLIENTE   = :CDCLIENTE) AND
                   (CDCONSUMIDOR  = :CDCONSUMIDOR)
                ORDER BY
                   CDCONSUMIDOR";
        $std = $this->connection->prepare($sql);
        $std->execute($row);
        return $std->fetchAll();
    }
    
    public function saveConsResp($params){
        $sql = "UPDATE CONSUMIDOR
                SET NRRGCONSUMID = :NRRGCONSUMID,
                    NRCPFRESPCON = :NRCPFRESPCON,
                    NMRESPCONS   = :NMRESPCONS,
                    NMLOGINCONS  = :NMLOGINCONS
                WHERE CDCONSUMIDOR = :CDCONSUMIDOR
                  AND CDCLIENTE    = :CDCLIENTE";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function changePasswordConsResp($params){
        $sql = "UPDATE CONSUMIDOR
                SET CDSENHASITE = :CDSENHASITE,
                    CDSENHACONSMD5 = :CDSENHACONSMD5
                    
                WHERE CDCONSUMIDOR = :CDCONSUMIDOR
                  AND CDCLIENTE    = :CDCLIENTE
                  AND UPPER(NMLOGINCONS)   = UPPER(:NMLOGINCONS)";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

}